"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _tiptap = require("tiptap");

var _prosemirrorTransform = require("prosemirror-transform");

var _prosemirrorCollab = require("prosemirror-collab");

var _socket = _interopRequireDefault(require("socket.io-client"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Collaboration = /*#__PURE__*/function (_Extension) {
  _inherits(Collaboration, _Extension);

  var _super = _createSuper(Collaboration);

  function Collaboration() {
    _classCallCheck(this, Collaboration);

    return _super.apply(this, arguments);
  }

  _createClass(Collaboration, [{
    key: "init",
    value: function init() {
      var _this = this;

      // Default version
      this.version = 0;
      this.initDone = false;
      this.getSendableSteps = this.debounce(function (state) {
        var sendable = (0, _prosemirrorCollab.sendableSteps)(state);

        if (sendable) {
          _this.version = sendable.version;

          _this.options.onSaving();

          _this.socket.emit('update', {
            version: sendable.version,
            steps: sendable.steps.map(function (step) {
              return step.toJSON();
            })
          });
        }
      }, this.options.debounce);
      this.getSendableSelection = this.debounce(function (state) {
        var selection = _this.options.keepFocusOnBlur || _this.editor.focused ? {
          from: state.selection.from,
          to: state.selection.to
        } : null;

        _this.socket.emit('updateSelection', {
          selection: selection
        });
      }, this.options.debounce);
      this.editor.on('transaction', function (_ref) {
        var state = _ref.state;

        if (_this.initDone) {
          _this.getSendableSteps(state);

          _this.getSendableSelection(state);
        }
      });
      this.socket = (0, _socket["default"])("".concat(this.options.socketServerBaseURL, "/").concat(this.options.namespace)).on('connect', function () {
        _this.initDone = false;

        _this.editor.unregisterPlugin('collab');

        _this.socket.emit('join', {
          roomName: _this.options.room,
          clientID: _this.options.clientID,
          options: _this.options.joinOptions
        });
      }).on('init', function (data) {
        _this.version = data.version;

        _this.editor.setContent(data.doc);

        _this.editor.registerPlugin((0, _prosemirrorCollab.collab)({
          version: _this.version,
          clientID: _this.options.clientID
        }));

        _this.initDone = true;

        _this.options.onConnected();
      }).on('initFailed', function (error) {
        _this.options.onConnectionRefused(error);
      }).on('update', function (data) {
        _this.update(data);

        if (data.version !== _this.version) {
          _this.options.onSaved();
        } else {
          _this.options.onSaveFailed('Version mismatch');
        }
      }).on('getSelections', function (data) {
        _this.updateSelections(data);
      }).on('getClients', function (clientsIDs) {
        _this.options.onClientsUpdate({
          clientsIDs: clientsIDs,
          clientID: _this.options.clientID
        });
      }).on('disconnect', function () {
        _this.options.onDisconnected();
      });
    }
  }, {
    key: "update",
    value: function update(_ref2) {
      var steps = _ref2.steps,
          version = _ref2.version;
      var _this$editor = this.editor,
          state = _this$editor.state,
          view = _this$editor.view,
          schema = _this$editor.schema;

      if ((0, _prosemirrorCollab.getVersion)(state) > version) {
        return;
      }

      view.dispatch((0, _prosemirrorCollab.receiveTransaction)(state, steps.map(function (item) {
        return _prosemirrorTransform.Step.fromJSON(schema, item.step);
      }), steps.map(function (item) {
        return item.clientID;
      })));
    }
  }, {
    key: "updateSelections",
    value: function updateSelections(cursors) {
      var cursorExtension = this.editor.extensions.extensions.find(function (e) {
        return e.name === 'cursors';
      });
      if (cursorExtension) cursorExtension.update(cursors);
    }
  }, {
    key: "closeSocket",
    value: function closeSocket() {
      this.socket.close();
    }
  }, {
    key: "debounce",
    value: function debounce(fn, delay) {
      var timeout;
      return function () {
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        if (timeout) {
          clearTimeout(timeout);
        }

        timeout = setTimeout(function () {
          fn.apply(void 0, args);
          timeout = null;
        }, delay);
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'collaboration';
    }
  }, {
    key: "defaultOptions",
    get: function get() {
      return {
        socketServerBaseURL: 'http://localhost:6000',
        namespace: '',
        room: '',
        clientID: String(Math.floor(Math.random() * 0xFFFFFFFF)),
        joinOptions: {},
        debounce: 250,
        keepFocusOnBlur: false,
        onConnected: function onConnected() {},
        onConnectionRefused: function onConnectionRefused() {},
        onDisconnected: function onDisconnected() {},
        onClientsUpdate: function onClientsUpdate() {},
        onSaving: function onSaving() {},
        onSaveFailed: function onSaveFailed() {},
        onSaved: function onSaved() {}
      };
    }
  }]);

  return Collaboration;
}(_tiptap.Extension);

exports["default"] = Collaboration;