"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _tiptap = require("tiptap");

var _prosemirrorView = require("prosemirror-view");

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Cursors = /*#__PURE__*/function (_Extension) {
  _inherits(Cursors, _Extension);

  var _super = _createSuper(Cursors);

  function Cursors() {
    _classCallCheck(this, Cursors);

    return _super.apply(this, arguments);
  }

  _createClass(Cursors, [{
    key: "getDecorations",
    value: function getDecorations(_ref) {
      var doc = _ref.doc,
          selections = _ref.selections;
      var clientID = this.editor.extensions.options.collaboration.clientID;
      var decorations = selections.filter(function (selection) {
        return selection.clientID !== clientID;
      }).map(function (selection) {
        var decors = [];

        if (selection.selection) {
          var _selection$selection = selection.selection,
              from = _selection$selection.from,
              to = _selection$selection.to;
          var span = document.createElement('span');
          span.className = "cursor client-".concat(selection.clientID);
          decors.push(_prosemirrorView.Decoration.widget(to, span));

          if (from !== to) {
            decors.push(_prosemirrorView.Decoration.inline(from, to, {
              nodeName: 'span',
              "class": "selection client-".concat(selection.clientID)
            }));
          }
        }

        return decors;
      }).flat();
      return _prosemirrorView.DecorationSet.create(doc, decorations);
    }
  }, {
    key: "update",
    value: function update(selections) {
      var tr = this.editor.state.tr;
      var transaction = tr.setMeta('selections', selections).setMeta('addToHistory', false);
      this.editor.view.dispatch(transaction);
    }
  }, {
    key: "name",
    get: function get() {
      return 'cursors';
    }
  }, {
    key: "defaultOptions",
    get: function get() {
      return {};
    }
  }, {
    key: "plugins",
    get: function get() {
      var _this = this;

      return [new _tiptap.Plugin({
        state: {
          init: function init(_, _ref2) {
            var doc = _ref2.doc;
            return _this.getDecorations({
              doc: doc,
              selections: []
            });
          },
          apply: function apply(transaction, decorationSet) {
            var mapping = transaction.mapping,
                doc = transaction.doc;
            var selections = transaction.getMeta('selections');

            if (selections) {
              return _this.getDecorations({
                doc: doc,
                selections: selections
              });
            }

            return decorationSet.map(mapping, doc);
          }
        },
        props: {
          decorations: function decorations(state) {
            return this.getState(state);
          }
        }
      })];
    }
  }]);

  return Cursors;
}(_tiptap.Extension);

exports["default"] = Cursors;